%{
unit expr;

interface

uses
	SysUtils,
	Classes,
	yacclib,
	lexlib,
        uStreamLexer,
        TrafficLight.Model;



%}

%token <Cardinal> NUM 
%token <TCustomLight> RED YELLOW GREEN
%token <TEventList> INIT ENDINIT LOOP ENDLOOP

%type <TCustomEvent> expr
%type <TCustomLight> light

%token ON OFF
%token WAIT

%token ILLEGAL 		/* illegal token */

%%

input	:  /* empty */
	|  _init _loop		 { yyaccept; }   
	;


_init   : INIT exprs ENDINIT 	 { FInitList.AddRange(FTemporaryList.ToArray); FTemporaryList.Clear; }
        ;

_loop   : LOOP exprs ENDLOOP	 { FLoopList.AddRange(FTemporaryList.ToArray); FTemporaryList.Clear }
        ;

exprs   :  /* empty */
	|  exprs expr 		 { FTemporaryList.Add($2); }
        ;

expr    :  WAIT NUM		 { $$ := TWaitEvent.Create($2); }
	|  light ON		 { $$ := TLightOnEvent.Create($1); }
	|  light OFF		 { $$ := TLightOffEvent.Create($1); }
	;

light   :  RED			 { $$ := FRedLight; }
        |  YELLOW		 { $$ := FYellowLight; }
        |  GREEN		 { $$ := FGreenLight; }
	;

%%

{$I exprlex.pas}

end.